var day = [
    'rrule.day.sunday',
    'rrule.day.monday',
    'rrule.day.tuesday',
    'rrule.day.wednesday',
    'rrule.day.thursday',
    'rrule.day.friday',
    'rrule.day.saturday'
]

export default {
    methods: {
        leadingZero(num) {
            if (num < 10) {
                return '0' + num
            } else {
                return num.toString()
            }
        },

        apiDate: function (date) {
            var d = new Date(date)
            return d.getFullYear() + '-' + this.leadingZero(d.getMonth() + 1) + '-' + this.leadingZero(d.getDate())
        },
        getWeekdayFromApiDate: function (date) {
            let d = new Date(date)
            let w = d.getDay()
            // Date.getDay() returns 0 for Sundays, but for our APIs we need 0 for Mondays
            if (w === 0) {
                return 6
            } else {
                return w - 1
            }
        },
        prettyDate: function (date) {
            var d = new Date(date)

            return d.toLocaleString(
                this.$activeLocale(),
                {
                    weekday: 'long',
                    day: 'numeric',
                    month: 'long',
                    year: 'numeric',
                }
            )
        },

        prettyTime: function(date) {
            var d = new Date(date);

            return d.toLocaleString(
                this.$activeLocale(),
                {
                    hour: '2-digit',
                    minute: '2-digit',
                }
            )
        },

        prettyDateTime: function (date) {
            var d = new Date(date)

            return d.toLocaleString(
                this.$activeLocale(),
                {
                    weekday: 'long',
                    day: 'numeric',
                    month: 'long',
                    year: 'numeric',
                    hour: '2-digit',
                    minute: '2-digit',
                }
            )
        },
        prettyHours(hours) {
            return hours.replace(/:00$/, '');
        },
        prettyDuration: function (start, end) {
            var seconds = (new Date(end).getTime() - new Date(start).getTime()) / 1000
            var minutes = Math.floor(seconds / 60)
            var duration = minutes + 'min'
            if (minutes < seconds / 60) {
                duration += ' '
                duration += seconds - 60 * minutes
                duration += 'sec'
            }
            return { duration, minutes }
        },
        durationInSeconds: function (ns) {
            const durationInMilliseconds = Math.floor(ns / 1000 / 1000);

            return Math.floor(durationInMilliseconds / 1000);
        },
        prettyNanoseconds: function (ns) {
            const durationInMilliseconds = Math.floor(ns / 1000 / 1000);

            const seconds = parseInt((durationInMilliseconds / 1000) % 60),
                minutes = parseInt((durationInMilliseconds / (1000 * 60)) % 60),
                hours = parseInt((durationInMilliseconds / (1000 * 60 * 60)) % 24);

            return this.leadingZero(hours) + ':' + this.leadingZero(minutes) + ':' + this.leadingZero(seconds)
        },
        nanosecondsToMinutes: function (ns) {
            return ns / 1000 / 1000 / 1000 / 60;
        },
        hmsToNanoseconds: function (hms) {
            const parts = hms.split(':');
            const seconds = (+parts[0]) * 60 * 60 + (+parts[1]) * 60 + (+parts[2]);

            return seconds * 1000 * 1000 * 1000;
        },
        minutesToHm: function(minutes) {
            var m = minutes % 60;
            var h = (minutes-m)/60;

            return `${this.leadingZero(h)}:${this.leadingZero(m)}`;
        },
        prettyWeekday: function (weekday) {
            let w;

            if (weekday === 6) {
                w = 0
            } else {
                w = weekday + 1
            }

            return this.$t(day[w]);
        }
    }
}
